/*
 * Prolog Example File
 */

% fibonacci(1) = 1
% fibonacci(2) = 1
% fibonacci(n) = fibonacci(n-1) + fibonacci(n-2).

fib(1,1).
fib(2,1).

fib(N,F) :- N > 2, 
    N1 is N-1, 
    N2 is N-2,
    fib(N1,F1),
    fib(N2,F2),
    F is F1 + F2.
        


% predicate substitute(X,Y,Xs,Ys) that is true if the list Ys is the result of
% substituting Y for all occurrences of X in the list Xs.
substitute(_,_,[],[]).
substitute(X,Y,[X|Tx],[Y|Ty]) :- substitute(X,Y,Tx,Ty).
substitute(X,Y,[Z|Tx],[Z|Ty]) :- not(X = Z), substitute(X,Y,Tx,Ty). 

